from rocolib.api.components.Component import Component

c = Component()

#NEEDS CLEANING
#Don't change n yet, haven't figured out how to make it n-wheeled
#8-Wheeled Pivot Car
n = 3 #(number of wheels - 1)/2
c.addParameter("length", 76, paramType="length", minValue=76) #tested minValue
c.addParameter("height", 36, paramType="length", minValue=36) #tested minValue
c.addParameter("width", 60, paramType="length", minValue=60) #tested minValue

for i in range(n - 1):
    c.addSubcomponent("front%d" %i, "HalfCar")
    c.addConstraint(("front%d" %i, "length"), "length")
    c.addConstraint(("front%d" %i, "height"), "height")
    c.addConstraint(("front%d" %i, "width"), "width")
    c.addSubcomponent("middle%d" %i, "HalfCar")
    c.addConstraint(("middle%d" %i, "length"), "length")
    c.addConstraint(("middle%d" %i, "height"), "height")
    c.addConstraint(("middle%d" %i, "width"), "width")

#Main component of steering wheel car which makes them moveable: trapezoid that connects the two half of the car
for i in range(4 * n):
    c.addSubcomponent("midsupport%d" %i, "Trapezoid")
    c.addConstraint(("midsupport%d" %i, "width"), "width", "x-10")
    c.addConstraint(("midsupport%d" %i, "depth"), "width", "x-37")
    c.addConstraint(("midsupport%d" %i, "bangle"), "width",
                    "float(np.atan((x-37)/5)* 180 * 0.318309)")

c.addConnection(("middle1", "rect4.l"), ("midsupport0", "botedge"))
c.addConnection(("middle1", "rect4.r"), ("midsupport1", "botedge"))
c.addConnection(("front1", "rect4.l"), ("midsupport2", "botedge"))

c.addConnection(("middle1", "rect3.r"), ("midsupport3", "botedge"))
c.addConnection(("middle1", "rect3.l"), ("midsupport4", "botedge"))
c.addConnection(("front1", "rect3.l"), ("midsupport5", "botedge"))

c.addConnection(("middle0", "rect4.l"), ("midsupport6", "botedge"))
c.addConnection(("middle0", "rect4.r"), ("midsupport7", "botedge"))
c.addConnection(("front0", "rect4.l"), ("midsupport8", "botedge"))

c.addConnection(("middle0", "rect3.r"), ("midsupport9", "botedge"))
c.addConnection(("middle0", "rect3.l"), ("midsupport10", "botedge"))
c.addConnection(("front0", "rect3.l"), ("midsupport11", "botedge"))

c.addConnection(("midsupport4", "topedge"), ("midsupport5", "topedge"))
c.addConnection(("midsupport10", "topedge"), ("midsupport11", "topedge"))
c.addConnection(("midsupport9", "topedge"), ("midsupport3", "topedge"))

#Putting the brains in front component of the car
c.addParameter("brains", "esp32stack", paramType="dimension")
c.addParameter("driveservo", "fs90r", paramType="dimension")

for i in range(2):
    c.addSubcomponent("split%d" %i, "SplitEdge")
    c.addConstraint(("split%d" % i, "toplength"), "length", '(x,)')
    c.addConstraint(("split%d" % i, "botlength"), ("length", "height"),
                    '(x[1], x[0]-x[1])')
    c.addSubcomponent("holder%d" %i, "ESP32Stack")
    c.addConstraint(("holder%d" %i, "length"), "width")
    c.addConstraint(("holder%d" %i, "heightChanger"), ("brains", "height"), ("x[1] - getDim(x[0], 'height')"))
    c.addConstraint(("holder%d" %i, "length"), "width")

c.addConnection(("front0", "rect3.t"), ("split0", "topedge0"))
c.addConnection(("front1", "rect3.t"), ("split1", "topedge0"))

c.addConnection(("holder0", "rect2.t"), ("front0", "rect2.r"), angle=-90)
c.addConnection(("holder1", "rect2.t"), ("front1", "rect2.r"), angle=-90)

#Putting servo hinge between cars
for i in range(3):
    c.addSubcomponent("hinge%d" %i, "HingeServo")
    c.addConstraint(("hinge%d" % i, "length"), "length")
    c.addConstraint(("hinge%d" % i, "width"), "width")
    c.addSubcomponent("hingeSplit%d" %i, "SplitEdge")
    c.addConstraint(("hingeSplit%d" %i, "toplength"), "height", '(x,)')
    c.addConstraint(("hingeSplit%d" %i, "botlength"), ("height", "driveservo"),
                        '((x[0]-getDim(x[1], "motorheight"))/2, getDim(x[1], "motorheight"), '
                        '(x[0]-getDim(x[1], "motorheight"))/2)')

c.addSubcomponent("rectAssist", "Rectangle")
c.addConstraint(("rectAssist", "l"), "driveservo", 'getDim(x, "motorheight")')
c.addConstraint(("rectAssist", "w"), "length")

c.addConnection(("front0", "rect1.r"), ("hingeSplit0", "topedge0"))
c.addConnection(("hingeSplit0", "botedge1"), ("hinge0", "belt2.r"), angle=-90)

c.addConnection(("middle1", "rect1.r"), ("hingeSplit1", "topedge0"))
c.addConnection(("hingeSplit1", "botedge1"), ("hinge1", "belt2.r"), angle=-90)

c.addConnection(("middle0", "rect2.r"), ("hingeSplit2", "topedge0"))
c.addConnection(("hingeSplit2", "botedge1"), ("rectAssist", "t"), angle=-180)
c.addConnection(("rectAssist", "b"), ("hinge2", "belt0.r"), angle=90)

# c.addConnection(("hinge0", "servo.mount"), ("midsupport4", "face0"))

c.toLibrary("Centipede")
