
from rocolib.api.components.Component import Component

c = Component()

c.addParameter("length", 76, paramType="length", minValue=65) #tested minValue
c.addParameter("width", 60, paramType="length", minValue=60) #tested minValue

c.addSubcomponent("servo", "MountedServo")
c.addParameter("driveservo", "fs90r", paramType="dimension")
c.addConstraint(("servo", "servo"), "driveservo")
c.addConstraint(("servo", "length"), "driveservo", 'getDim(x, "motorlength") + 2 * getDim(x, "shoulderlength")')
c.addConstConstraint(("servo", "center"), False)

for i in range(5):
    c.addSubcomponent("belt%d" %i, "Rectangle")
    c.addConstraint(("belt%d"%i, "w"), "driveservo", 'getDim(x, "motorheight")')

for i in range(3):
    c.addConstraint(("belt%d"%i, "l"), ("width", "driveservo"), "(x[0]-getDim(x[1], 'motorwidth'))/2")

for i in range(3, 5):
    c.addConstraint(("belt%d" % i, "l"), "driveservo", 'getDim(x, "motorlength") + 2 * getDim(x, "shoulderlength")')

# for i in range(6, 10):
#     c.addConstraint(("belt%d"%i, "l"), "length")

c.addConnection(("servo", "botedge3"), ("belt0", "l"), angle=-90)
c.addConnection(("servo", "botedge1"), ("belt1", "l"), angle=-90)
c.addConnection(("servo", "topedge1"), ("belt3", "l"), angle=-180)
c.addConnection(("servo", "topedge3"), ("belt4", "l"), angle=-180)
c.addConnection(("belt2", "l"), ("belt4", "r"), angle=90)

# c.addConnection(("belt0", "r"), ("belt6", "l"), angle=90)
# c.addConnection(("belt1", "r"), ("belt7", "l"), angle=90)
# c.addConnection(("belt2", "r"), ("belt8", "l"), angle=-90)
# c.addConnection(("belt3", "r"), ("belt9", "l"), angle=-90)

c.inheritAllInterfaces("servo")
for i in range(3):
    c.inheritAllInterfaces("belt%d" %i)

c.toLibrary("HingeServo")