from rocolib.api.components.Component import Component

c = Component()
#N-WHEELED CAR (10-wheeed car)
#Probably need to additional microcontroller in the middle for N > 8
n = 4 #(number of wheels/2) - 1
c.addParameter("length", 76, paramType="length", minValue=76) #tested minValue
c.addParameter("height", 36, paramType="length", minValue=36) #tested minValue
c.addParameter("width", 60, paramType="length", minValue=60) #tested minValue

c.addSubcomponent("front", "HalfCar") #must always have a front car for the brains
c.addConstraint(("front", "length"), "length")
c.addConstraint(("front", "height"), "height")
c.addConstraint(("front", "width"), "width")

#Connecting Each Car
for i in range(n):
    c.addSubcomponent("car%d" %i, "HalfCar")
    c.addConstraint(("car%d" %i, "length"), "length")
    c.addConstraint(("car%d" %i, "height"), "height")
    c.addConstraint(("car%d" %i, "width"), "width")

for i in range(n - 1):
    c.addConnection(("car%d" %i, "rect4.l"), ("car%d" %(i+1), "rect4.r"))

c.addConnection(("front", "rect4.l"), ("car%d" %(n-1), "rect4.l"))

#Putting the brains in the front of the car
c.addParameter("brains", "esp32stack", paramType="dimension")
c.addParameter("driveservo", "fs90r", paramType="dimension")
c.addSubcomponent("holder", "ESP32Stack")

c.addConstraint(("holder", "heightChanger"), ("brains", "height"), ("x[1] - getDim(x[0], 'height')"))
c.addConstraint(("holder", "length"), "width")

c.addConnection(("holder", "rect2.t"), ("front", "rect2.l"), angle=-90)

c.toLibrary("NWheeledCar")
