from rocolib.api.components import FoldedComponent
from rocolib.api.composables.graph.Face import Face

class RightTriangle(FoldedComponent):

    def define(self):
        self.addParameter("height", 3, paramType="length")
        self.addParameter("base", 4, paramType="length")
        self.addParameter("hypotenuse", 5, paramType="length")
        self.addParameter("angle", 45, paramType="angle", minValue=45, maxValue=45)

        self.addEdgeInterface("hedge", "r0.e0", "height")
        self.addEdgeInterface("bedge", "r0.e1", "base")
        self.addEdgeInterface("hypoedge", "r0.e2", "hypotenuse")

    def assemble(self):
        h = self.getParameter("height")
        b = self.getParameter("base")
        x = h**2 + b**2

        rs = []
        rs.append(Face("", ((b, 0), (0,0), (0, -h))))
        self.attachEdge(None, rs[0], "e0", prefix="r0", angle=90)


if __name__ == "__main__":
    RightTriangle.test()

